%===============================================================================
%NOME: erro.pl
%
%Projeto: Correo de Programas
%
%   Verso: V 1.00
%   Autora : Juliana Carpes Imperial - 0124811-7
%
%Descrio do mdulo
%   Objetivo:
%      - tratar erro durante as operaes de abertura, leitura, escrita e
%        fechamento em arquivos.
%===============================================================================


%===============================================================================
%Nome: tratarErro
%Descrio do predicado: trata o erro que aconteceu durante as operaes com 
%                        arquivos.
%
%Varivel de entrada: 
%   - Erro: o tipo do erro que aconteceu.
%
%Assertiva de entrada:
%   - o arquivo com o programa ALP est aberto.
%
%Assertiva de sada:
%   - o arquivo com o programa ALP est fechado e o programa foi abortado.
%===============================================================================

% exibe as mensagens adequadas para cada tipo de erro (abertura, leitura,
% escrita e fechamento de arquivo) e, por fim, fecha o arquivo e aborta o
% programa
tratarErro( Erro )                                              :-
   catch( seen, _Excecao, true )                                ,
   catch( told, _Excecao, true )                                , 
   ( ( Erro == abertura                                         , 
       write( '\nErro durante a abertura do arquivo.\n' ) )     ;
     ( Erro == escrita                                          ,
       write( '\nErro durante a escrita no arquivo.\n' ) )      ;
     ( Erro == leitura                                          ,
       write( '\nErro durante a leitura do arquivo.\n' ) )      ;
     ( Erro == fechamento                                       ,
       write( '\nErro durante o fechamento do arquivo.\n' ) ) ) ,
   abort                                                        .     