%===============================================================================
%NOME: principal.pl
%
%Projeto: Correo de Programas
%
%   Verso: V 1.00
%   Autora : Juliana Carpes Imperial - 0124811-7
%
%Descrio do mdulo
%   Objetivo:
%      - ser o mdulo principal do corretor de programas.
%===============================================================================


%===============================================================================
%Descrio da consulta: carrega os demais arquivos com o cdigo-fonte do 
%                       corretor de programas no interpretador de Prolog.
%===============================================================================

:- [ 'erro.pl', 'lexica.pl', 'sintatica.pl', 'condicoes.pl', 'expressoes.pl' ] , 
   [ 'hoare.pl' ]                                                              .


%===============================================================================
%Nome: fazerAnalise
%Descrio do predicado: executa todos os passos necessrios para realizar a
%                        correo formal de um programa.
%===============================================================================

% faz a anlise lxica e sinttica de um programa. Posteriormente, l as pr e
% ps condies, e os invariantes. Depois, aplica o clculo de hoare no programa
% para provar a sua correo. Por fim, pega as vrias provas diferentes obtidas
% e retira algumas de forma que as resultantes tenham o conjunto de sentenas a
% ser provado diferentes entre si, colocando-as em uma pgina HTML
corrigirPrograma                                                             :-
   fazerAnaLexica( Tokens )                                                  ,
   fazerAnaSintatica( Tokens, Arvore )                                       ,
   lerCondicoes( Tokens, Invars, PreCond, PosCond )                          ,
   setof( [ Prova, Sents ],
            fazerHoare( Invars, PreCond, Arvore, PosCond, Prova, [ ], Sents ),
            Respostas )                                                      ,
   retirarProvas( Respostas, NovasResp, [ ] )                                ,
   imprimirSaida( NovasResp )                                                .
